unit Pci_errors;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons, WIEnumComboBox, WIStringEdit,
  W5009SpinTune, W5009SpinEdit, WISpinEdit;

type
  TfErrors = class(TForm)
    ListBox1: TListBox;
    Panel1: TPanel;
    BranchButton: TBitBtn;
    RemoveButton: TBitBtn;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure RemoveButtonClick(Sender: TObject);
    procedure BranchButtonClick(Sender: TObject);
    procedure ListBox1DblClick(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure ReLoadButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fErrors: TfErrors = NIL;

implementation

uses Pci_main, Pci_Program;

{$R *.DFM}

procedure TfErrors.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
  fErrors := nil;
end;

procedure TfErrors.RemoveButtonClick(Sender: TObject);
begin
  if (ListBox1.ItemIndex >= 0) then
    ListBox1.Items.Delete(ListBox1.ItemIndex)
  else
    MessageDlg('You must first make a selection', mtWarning,[mbOk], 0);
  if (ListBox1.Items.Count <= 0) then begin
    RemoveButton.Enabled := FALSE;
    BranchButton.Enabled := FALSE;
  end;
end;

procedure TfErrors.BranchButtonClick(Sender: TObject);
begin
  if (ListBox1.ItemIndex >= 0) then
    ListBox1DblClick(Sender)
  else
    MessageDlg('You must first make a selection', mtWarning,[mbOk], 0);
end;

procedure TfErrors.ListBox1DblClick(Sender: TObject);
var
  Object1: TObject;
  Control: TControl;
  Point: TPoint;
begin
  if (fProgramMode <> nil) then begin
    fMain.tPing.Enabled := FALSE;
    with fErrors.ListBox1 do begin
      Object1 := Items.Objects[ItemIndex];
      fProgramMode.Show;
      if (Object1 is TControl) then begin
        Control := TControl(Object1);
        fProgramMode.OpenPageOf(Control);
        fProgramMode.ScrollInView(Control);
        if (   (Control is TWISpinEdit)
            or (Control is TW5009SpinEdit)
            or (Control is TW5009SpinTune)
            or (Control is TWIEnumComboBox)
            or (Control is TCheckBox)
            or (Control is TWIStringEdit) )
        then begin
          if (Control.Visible) then  TWinControl(Control).SetFocus;
          TWinControl(Control).SetFocus;
        end
        else begin
          Point.x := Control.Width div 2;
          Point.y := Control.Height div 2;
          Point := Control.ClientToScreen(Point);
          SetCursorPos(Point.x, Point.y);
        end;
      end; //if TControl...
      fMain.tPing.Enabled := TRUE;
    end; //with ListBox...
  end //if fProgramMode...
  else
    MessageBeep(0);
end;

procedure TfErrors.BitBtn1Click(Sender: TObject);
begin
  fMain.PassCCheck(FALSE);
  Close;
end;

procedure TfErrors.ReLoadButtonClick(Sender: TObject);
begin
  if (fProgramMode <> nil)  then
    fProgramMode.ExitProgramModeButtonClick(Sender);
end;

end.
