unit Pci_main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  WIForms, Menus, StdCtrls, Buttons, ExtCtrls, ComCtrls, WIDevice,
  WIServlinkControl, WIServer, WIEventManager, WIServLinkConfig, WIServlinkItem,
  Working, WLabel, WIItemSpy,
  WWriteComponents, W5009SpinEdit, W5009SpinTune, WIBoxLabel, WIEnumComboBox,
  WIStringEdit, WIDAOneShotButton, WIDAMomentaryButton, WIOneShotButton,
  WIMomentaryButton, WIToggleButton, WICheckBox;

type
  TFMain = class(TWIForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    Mode1: TMenuItem;
    Options1: TMenuItem;
    Windows1: TMenuItem;
    StatusBar1: TStatusBar;
    Program1: TMenuItem;
    Service1: TMenuItem;
    Run1: TMenuItem;
    Cascade1: TMenuItem;
    TileHorizontal: TMenuItem;
    TileVertical: TMenuItem;
    //tClock: TTimer;
    ProgramEdit: TMenuItem;
    ProgramViewOnly: TMenuItem;
    ServiceEdit: TMenuItem;
    ServiceViewOnly: TMenuItem;
    WIServer1: TWIServer;
    PrintDialog1: TPrintDialog;
    Printcurrentpage1: TMenuItem;
    WIServlinkConfig1: TWIServlinkConfig;
    tPing: TTimer;
    CCheckTimer: TTimer;
    Save1: TMenuItem;
    Loadfromfile1: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    tMain: TTimer;
    ProgramOnLineButton: TBitBtn;
    RunModeButton: TBitBtn;
    MainPanel: TPanel;
    ServiceModeButton: TBitBtn;
    ChangeProgrammodepassword1: TMenuItem;
    ChangeRunmodepassword1: TMenuItem;
    ChangeServicemodepassword1: TMenuItem;
    ChangeAdmisitratorpassword1: TMenuItem;
    N3: TMenuItem;
    SendValuesToControl: TMenuItem;
    WIServlinkControl1: TWIServlinkControl;
    BitBtn1: TBitBtn;
    AboutMenu1: TMenuItem;
    About1: TMenuItem;
    procedure Exit1Click(Sender: TObject);
    procedure Run1Click(Sender: TObject);
    procedure Cascade1Click(Sender: TObject);
    procedure TileHorizontalClick(Sender: TObject);
    procedure TileVerticalClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ProgramEditClick(Sender: TObject);
    procedure ProgramViewOnlyClick(Sender: TObject);
    procedure ServiceEditClick(Sender: TObject);
    procedure ServiceViewOnlyClick(Sender: TObject);
    procedure tMainTimer(Sender: TObject);
    procedure OnCommunicating(Sender: TObject);
    procedure Printcurrentpage1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure tPingTimer(Sender: TObject);
    procedure ProgramOnLineButtonClick(Sender: TObject);
    procedure CCheckTimerTimer(Sender: TObject);
    procedure ReportCCheckErrors;
    procedure PassCCheck(bReallyPass: boolean);
    procedure Loadfromfile1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure SuspendOtherAdvises;
    procedure RestartOtherAdvises;
    function UnMaximizeOtherModes(CurForm: TWIForm): boolean;
    procedure RunModeButtonClick(Sender: TObject);
    procedure ShowStatus( status: string );
    procedure NormalStatus;
    procedure About1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure OpenProgramEdit;
    procedure OpenServiceMode;
    procedure OpenRunMode;
    procedure Program1Click(Sender: TObject);
    function CheckPassword(sPassword: string; sMode: string): boolean;
    procedure GetOnLine;
    procedure GetOffLine;
    procedure UpdateChildrensMonStatus( Parent: TWinControl;
                                        bMonitorMode: Boolean );
    procedure DisplayPollingErrorAlarm;
    function  ExtractName(Pathname: string): string;
    procedure EnableRangeChecking(bEnable: BOOLEAN);
    procedure Print(FormImage: TBitmap);
    function  WaitTillRequestReady: boolean;
    function  WaitTillPingDone: boolean;
    function  bInConfMode: boolean;
    procedure DisablePing;
    function  ControlInLoadFromFileState: Boolean;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FMain: TFMain;
  Scale_W : integer;
  Scale_H : integer;
  bFirstActivation : boolean = TRUE;
  bServerReady : boolean = FALSE;
  CCheckTime : integer;
  bIsOnLine : boolean = FALSE;
  OpeningMode : integer = 0;
  nPollingErrorTime : integer = 0;
  bIsTiled : boolean = FALSE;
  tLastPing: TDateTime = 0;
  bInConfigureMode: Boolean = FALSE;
  bInPingSemaphor: Boolean = FALSE;
  bTerminated: Boolean = FALSE;

const
  SB_WIDTH = 13;
  NORMAL_PAGE_W = 632;
  NORMAL_PAGE_H = 345;// was 345
  START_STOP_PAGE_W = (NORMAL_PAGE_W - SB_WIDTH);
  SLPanel = 0;
  ControlStatusPanel = 1;
  NO_CHANGE_MODE = 0;
  CLOSE_MODE = 1;
  OPEN_MODE = 2;
  FINISH_CLOSE_MODE = 3;
  NO_MODE = 0;
  PGM_E_MODE = 1;
  PGM_V_MODE = 2;
  SERV_E_MODE = 3;
  SERV_V_MODE = 4;
  RUN_MODE = 5;

  ChildHeightOffset = 28;
  ChildWidthOffset = 8;
  sGAPErrorMsgRoot = 'CONF_CHK_1.ERRORS.MSG_O_';
  sGAPStartConfig = 'WGSPL.TST_CONFIG.IN';
  sGAPNumErrors = 'CONF_CHK_1.ERRORS.NUM_EVENTS';
  sGAPErrorNumRoot = 'CONF_CHK_1.ERRORS.EV_N_';
  sGAPErrorsFound = 'CONF_CHK_1.C_ERR_SW.B_SW';
  sGAPNoErrorsFound = 'CONF_CHK_1.N_ERR_DLY.DELAY';
  sGAPConfEnabled = 'Z_CPU_COM.EN_CONFIG.OR';
  sEnableRGCheck = 'Enable RG Blocks';

  RESET_STR = 'Waiting to re-establish communication';
  DFLT_PING_PERIOD = 5000;
  PING_VALID_TIME = 5.0 / (24.0*60.0*60.0); //5 seconds
  CFG_FILE_EXT = 'cfg';
  DFLT_CFG_FILENM = 'Dflt Config ID.cfg';
  DFLT_CFG_FILEDIR = 'C:\Upci';
  DFLT_SL_FILENM = 'C:\Program Files\Woodward\Servlink Server\5009.net';
  CONTROL_ID_NAME = 'Dflt Control ID';
  CFG_ID_NAME = 'Dflt Config ID';
  CFG_FILE_FILTER = 1;
  SL_FILE_FILTER = 2;
  PgmModePassword = '1113';
  ServModePassword = '1111';
  RunModePassword = '1111';
  IP_LOCK_CM = $0000DC00;

implementation

uses Pci_program, Pci_service, Pci_run, Pci_errors,
      Printers, Clipbrd, PCI_pwd, About;

{$R *.DFM}
procedure TFMain.FormCreate(Sender: TObject);
var
  iHeight : integer;
begin
  iHeight := GetSystemMetrics(SM_CYFULLSCREEN);
  if     (iHeight > 1000) then begin {1280x1024}
    Scale_W := 1256;
    Scale_H := 1400;
  end
  else if (iHeight > 700) then begin {1024x768}
    Scale_W := 1150;
    Scale_H := 1210;
  end
  else if (iHeight > 500) then begin {800x600}
    Scale_W := 1050;
    Scale_H := 990;
  end
  else begin  {else 640x480 (target system)}
    Scale_W := 1000;
    Scale_H := 890;
  end;
  FMain.Height := (Scale_H * FMain.Height) div 1000;
  FMain.Width := (Scale_W * FMain.Width) div 1000;
  PrintScale := poPrintToFit;
  bServerReady := FALSE;
end;

function TFMain.WaitTillRequestReady: Boolean;
var i : integer;
begin
  i := 0;
  while (i < 20 ) do
  begin
    if (not WIServlinkControl1.IsExecutePending) then begin
      WaitTillRequestReady := TRUE;
      exit;
    end;
    sleep(50);
    i := i+1;
  end;
  WaitTillRequestReady := FALSE;
end;

function TFMain.WaitTillPingDone: Boolean;
var i : integer;
begin
  i := 0;
  if bInPingSemaphor then begin
    tPing.Interval := 200;
    tPing.Enabled := FALSE;
    tPing.Enabled := TRUE;
  end;
  while (i < 120) do //(This will exceed the "default Ping Period" by 1 second)
  begin
    if (not bInPingSemaphor) then begin
      WaitTillPingDone := TRUE;
      exit;
    end;
    sleep(50);
    i := i+1;
  end;
  raise Exception.Create('Wait for ping to finish timed out.');
  WaitTillPingDone := FALSE;
end;

procedure TFMain.DisablePing;
begin
  bInPingSemaphor := FALSE;
  tPing.Enabled := FALSE;
end;

function TFMain.bInConfMode: Boolean;
var
  bPinging: Boolean;
begin
 bPinging := tPing.Enabled;
 if bPinging then begin
 if (Time - tLastPing) < PING_VALID_TIME then begin
   bInConfMode := bInConfigureMode;
   exit;
  end;
 end;

 WaitTillPingDone;
 DisablePing;
 try
  bInConfigureMode := WIServlinkControl1.IsInConfigureMode;
except
 Beep;
  bInConfigureMode := FALSE;
end;
 if bPinging then tPing.Enabled := TRUE;
bInConfMode := bInConfigureMode;
//bInConfigureMode := TRUE; //test only for netsim to remove
//bInConfMode := TRUE;  //test only for netsim
end;

procedure TFMain.GetOffLine;
begin
  if bIsOnLine then begin
    WIServlinkControl1.Identifier := ' ';
    WIServlinkControl1.Server := nil;
    WIServer1.NetworkDefFiles.Clear;
    bIsOnLine := FALSE;
    StatusBar1.Panels[ControlStatusPanel].text := 'Control Status:  Not Connected';
  end;
end;

procedure TFMain.GetOnLine;
var
  NetDefArray: array [0..100] of char;
  pString: pChar;
  FileList: TStringList;
  pFName: pChar;
  NetDefString, TopicStr: string;
begin
  if not bIsOnLine then begin
    OpenDialog1.DefaultExt := 'net';
    OpenDialog1.FilterIndex := SL_FILE_FILTER;
    OpenDialog1.Title := 'Select Servlink network definition file';
    OpenDialog1.FileName := DFLT_SL_FILENM;
    if OpenDialog1.Execute then begin
      WIServer1.ServerName := 'UPCIServlink';
      ShowStatus('Starting Server');
      FMain.Cursor := crHourGlass;
      FileList := TStringList.Create;
      FileList.Add(OpenDialog1.FileName);
      WIServer1.NetworkDefFiles.Assign(FileList);
      pString := StrPCopy(NetDefArray, WIServer1.NetworkDefFiles.Strings[0]);
      TopicStr := CONTROL_ID_NAME;
      pFName := StrRScan(pString, '\');
      if pFName <> nil then begin
        inc(pFName);
        NetDefString := StrPas(pFName);
        NetDefString := NetDefString + '(' + TopicStr + ')';
        WIServlinkControl1.Identifier := NetDefString;
      end;
    end;
  end;
end;

procedure TFMain.FormActivate(Sender: TObject);
begin
  if bFirstActivation then begin
    WIServlinkControl1.OnCommunicationActive := OnCommunicating;
    Save1.Enabled := FALSE;
    Loadfromfile1.Enabled := FALSE;
    bFirstActivation := FALSE;
  end;
end;

procedure TFMain.Exit1Click(Sender: TObject);
begin
  Close();
end;

procedure TFMain.ShowStatus( status: string );
begin
  DisablePing;
  Cursor := crHourGlass;
  FWorking.Visible := TRUE;
  FWorking.Label1.Caption := status;
  FWorking.Show;
  MainPanel.Enabled := FALSE;
end;

procedure TFMain.NormalStatus;
begin
  fWorking.Visible := FALSE;
  MainPanel.Enabled := TRUE;
  Cursor := crDefault;
  if (bIsOnLine) then begin
    tPing.Interval := 200; //Quick initial feedback
    tPing.Enabled := TRUE;
  end;
end;

procedure TFMain.About1Click(Sender: TObject);
begin
  Application.CreateForm(TAboutBox, AboutBox);
  AboutBox.ShowModal;
  AboutBox.Free;
end;



procedure TFMain.OpenProgramEdit;
var
  bMaximize: Boolean;
begin
  bMaximize := not (UnMaximizeOtherModes(TWIForm(FProgramMode)));
  if (FProgramMode = nil) then begin
    FProgramMode := TFProgramMode.Create(FMain);
    PModeOldHeight := FProgramMode.Height;
    PModeOldWidth := FProgramMode.Width;
    PModeDefaultHeight := FProgramMode.PageControl1.Height + ChildHeightOffset;
    PModeDefaultWidth := FProgramMode.PageControl1.Width + ChildWidthOffset;
  end
  else begin
    fProgramMode.ResetSheetMonStatus;
    FProgramMode.UpdateMonStatus(ProgramEdit.Checked = FALSE);
  end;

  fProgramMode.ExitProgramModeButton.Enabled := ProgramEdit.Checked;

  FProgramMode.UpdateFormCaption;
  if (bMaximize) then
    FProgramMode.WindowState := wsMaximized;
  FProgramMode.Show;
  NormalStatus;
end;

function TFMain.CheckPassword(sPassword: string; sMode: string): boolean;
begin
  sModeName := sMode;
  sRequiredPwd := sPassword;
  if (fPassword.ShowModal = mrOK) then CheckPassword := TRUE
  else                                 CheckPassword := FALSE;
end;

procedure TFMain.ProgramEditClick(Sender: TObject);
var
  CurItem: TWIServlinkItem;
begin
  if not bIsOnLine then begin
    OpeningMode := PGM_E_MODE;
    GetOnLine; //This should result in a callback that will re-call this
    exit;      //function with bIsOnLine=TRUE;
  end;

  if fRunMode <> nil then begin
    MessageDlg('The Run window must be closed before entering program mode.', mtInformation, [mbOK], 0);
    NormalStatus;
    exit;
  end;

  if not bInConfMode then begin
    try
      CurItem := WIServlinkControl1.GetServlinkItemObject(sGAPConfEnabled);
      if (CurItem.Value <> '1') then begin
        MessageDlg('Configure mode is not enabled on the control (Control must be shut down).', mtInformation, [mbOK], 0);
        NormalStatus;
        exit;
      end
    except
      MessageDlg('Configure mode check failed!', mtWarning, [mbOK], 0);
    end;

    if CheckPassword(PgmModePassword, 'Program') then begin
      WIServlinkControl1.Shutdown;
      tPing.Interval := 200; //Speed up initial update of this info.
    end
    else begin
      NormalStatus;
      exit;
    end;
  end
  else if not CheckPassword(PgmModePassword, 'Program') then
    exit;

  Program1.Checked := TRUE;
  ProgramEdit.Checked := TRUE;

  MainPanel.Visible := FALSE;

  ShowStatus('Opening Program Mode');
  ChangeProgramMode := OPEN_MODE;
  tMain.Enabled := FALSE;
  tMain.Enabled := TRUE;
end;

procedure TFMain.ProgramViewOnlyClick(Sender: TObject);
begin
  if not bIsOnLine then begin
    OpeningMode := PGM_V_MODE;
    GetOnLine; //This should result in a callback that will re-call this
    exit;      //function with bIsOnLine=TRUE;
  end;
  Program1.Checked := TRUE;
  ProgramViewOnly.Checked := TRUE;
  MainPanel.Visible := FALSE;
  ShowStatus('Opening Program Monitor Mode');

  ChangeProgramMode := OPEN_MODE;
  tMain.Enabled := FALSE;
  tMain.Enabled := TRUE;
end;

procedure TFMain.OpenServiceMode;
var
  bMaximize : boolean;
begin
  bMaximize := not (UnMaximizeOtherModes(TWIForm(FServiceMode)));
  if (FServiceMode = nil) then begin
    FServiceMode := TFServiceMode.Create(FMain);
    SModeOldHeight := FServiceMode.Height;
    SModeOldWidth := FServiceMode.Width;
    SModeDefaultHeight := FServiceMode.PageControl1.Height + ChildHeightOffset;
    SModeDefaultWidth := FServiceMode.PageControl1.Width + ChildWidthOffset;
    FServiceMode.InitMonStatus;
  end
  else begin
    fServiceMode.ResetSheetMonStatus;
    FServiceMode.UpdateMonStatus(ServiceEdit.Checked = FALSE);
  end;
  FServiceMode.UpdateFormCaption;
  if (bMaximize) then
    FServiceMode.WindowState := wsMaximized;
  FServiceMode.Show;
  NormalStatus;
end;

procedure TFMain.ServiceEditClick(Sender: TObject);
begin
  if not bIsOnLine then begin
    OpeningMode := SERV_E_MODE;
    GetOnLine; //This should result in a callback that will re-call this
    exit;      //function with bIsOnLine=TRUE;
  end;
  if not CheckPassword(ServModePassword, 'Service') then
    exit;
  MainPanel.Visible := FALSE;
  Service1.Checked := TRUE;
  ServiceEdit.Checked := TRUE;
  ShowStatus('Opening Service Mode');
  ChangeServiceMode := OPEN_MODE;
  tMain.Enabled := FALSE;
  tMain.Enabled := TRUE;
end;

procedure TFMain.ServiceViewOnlyClick(Sender: TObject);
begin
  if not bIsOnLine then begin
    OpeningMode := SERV_V_MODE;
    GetOnLine; //This should result in a callback that will re-call this
    exit;      //function with bIsOnLine=TRUE;
  end;
  MainPanel.Visible := FALSE;
  Service1.Checked := TRUE;
  ServiceViewOnly.Checked := TRUE;
  ShowStatus('Opening Service Monitor Mode');
  ChangeServiceMode := OPEN_MODE;
  tMain.Enabled := FALSE;
  tMain.Enabled := TRUE;
end;

procedure TFMain.OpenRunMode;
var
  bMaximize: Boolean;
begin
  bMaximize := not (UnMaximizeOtherModes(TWIForm(FRunMode)));
  if (FRunMode = nil) then begin
    FRunMode := TFRunMode.Create(FMain);
    RModeOldHeight := FRunMode.Height;
    RModeOldWidth := FRunMode.Width;
    RModeDefaultHeight := FRunMode.PageControl1.Height + ChildHeightOffset;
    RModeDefaultWidth := FRunMode.PageControl1.Width + ChildWidthOffset;
  end;
  FRunMode.UpdateFormCaption;
  Run1.Checked := TRUE;
  if (bMaximize) then FRunMode.WindowState := wsMaximized;
  FRunMode.show;
  NormalStatus;
end;

procedure TFMain.Run1Click(Sender: TObject);
begin
  if not bIsOnLine then begin
    OpeningMode := RUN_MODE;
    GetOnLine; //This should result in a callback that will re-call this
    exit;      //function with bIsOnLine=TRUE;
  end;
  if bInConfMode then begin
    MessageDlg('The control is in program mode.  You must save values from the Program Edit mode before running.', mtInformation, [mbOK], 0);
    NormalStatus;
  end
  else begin
    MainPanel.Visible := FALSE;
    ShowStatus('Opening Run Mode');
    ChangeRunMode := OPEN_MODE;
    tMain.Enabled := FALSE;
    tMain.Enabled := TRUE;
  end;
end;

procedure TFMain.Cascade1Click(Sender: TObject);
begin
  FMain.Cascade;
  bIsTiled := FALSE;
end;

procedure TFMain.TileHorizontalClick(Sender: TObject);
begin
  FMain.TileMode := tbHorizontal;
  FMain.Tile;
  bIsTiled := TRUE;
end;

procedure TFMain.TileVerticalClick(Sender: TObject);
begin
  FMain.TileMode := tbVertical;
  FMain.Tile;
end;

procedure TFMain.OnCommunicating(Sender: TObject);
begin
  DisablePing;
  bServerReady := TRUE;
  bIsOnLine := TRUE;
  Save1.Enabled := TRUE;
  Loadfromfile1.Enabled := TRUE;

  case OpeningMode of
    PGM_E_MODE:  begin
      ProgramEditClick(Sender);
    end;
    PGM_V_MODE:  begin
      ProgramViewOnlyClick(Sender);
    end;
    SERV_E_MODE: begin
      ServiceEditClick(Sender);
    end;
    SERV_V_MODE: begin
      ServiceViewOnlyClick(Sender);
    end;
    RUN_MODE:  begin
      Run1Click(Sender);
    end;
    else       begin
      NormalStatus;
      tPing.Interval := 200; //Quick initial feedback for status of communications.
      tPing.Enabled := TRUE; //tPing will reset the interval after one call.
      tMain.Enabled := TRUE;
    end;
  end; //case
  OpeningMode := NO_MODE;
end;


//This timer is used for opening and closing modes.  A timer is required in order
//that "multitasking" works and doesn't cause problems.  For example, the timer
//allows the status window to paint itself.
procedure TFMain.tMainTimer(Sender: TObject);
var
  bPending : boolean;
begin
  tMain.Enabled := FALSE;
  tMain.Interval := 100;
  bPending := FALSE; //Represents need to return to this function after another time interval

  if (ChangeProgramMode = CLOSE_MODE) then
    begin
      ProgramEdit.Checked := False;
      ProgramViewOnly.Checked := False;
      Program1.Checked := False;
      if (FProgramMode <> nil) then begin
        FProgramMode.Release;
        FProgramMode := nil;
        ChangeProgramMode := FINISH_CLOSE_MODE;
        tMain.Interval := 1000;
        tMain.Enabled := True;
        bPending := True;;
      end
      else
        ChangeProgramMode := NO_CHANGE_MODE;
    end
  else if (ChangeProgramMode = FINISH_CLOSE_MODE) then
    begin
      ChangeProgramMode := NO_CHANGE_MODE;
      Enabled := True;
      //Now the main & status windows can be updated...
    end
  else if (ChangeProgramMode = OPEN_MODE) then
    begin
      ChangeProgramMode := NO_CHANGE_MODE;
      OpenProgramEdit;
    end;
  if (ChangeServiceMode = CLOSE_MODE) then
    begin
      FServiceMode.Release;
      FServiceMode := nil;
      ServiceEdit.Checked := False;
      ServiceViewOnly.Checked := False;
      Service1.Checked := False;
      ChangeServiceMode := FINISH_CLOSE_MODE;
      tMain.Interval := 1000;
      tMain.Enabled := True;
      bPending := True;;
    end
  else if (ChangeServiceMode = FINISH_CLOSE_MODE) then
    begin
      ChangeServiceMode := NO_CHANGE_MODE;
      Enabled := True;
      //Now the main & status windows can be updated...
    end
  else if (ChangeServiceMode = OPEN_MODE) then
    begin
      ChangeServiceMode := NO_CHANGE_MODE;
      OpenServiceMode;
    end;
  if (ChangeRunMode = CLOSE_MODE) then
    begin
      FRunMode.Release;
      FRunMode := nil;
      Run1.Checked := False;
      ChangeRunMode := FINISH_CLOSE_MODE;
      tMain.Interval := 1000;
      tMain.Enabled := True;
      bPending := True;
    end
  else if (ChangeRunMode = FINISH_CLOSE_MODE) then
    begin
      ChangeRunMode := NO_CHANGE_MODE;
      Enabled := True;
      //Now the main & status windows can be updated...
    end
  else if (ChangeRunMode = OPEN_MODE) then
    begin
      ChangeRunMode := NO_CHANGE_MODE;
      OpenRunMode;
    end;

  if (not bPending) then begin //will be returning to this code on next timer time
    if (  ((fProgramMode = nil) or (fProgramMode.WindowState <> wsMaximized))
      and ((fServiceMode = nil) or (fServiceMode.WindowState <> wsMaximized))
      and ((fRunMode     = nil) or (fRunMode.WindowState     <> wsMaximized)) )
    then begin
      if (MainPanel.Visible = False) then begin
        MainPanel.Visible := True;
        if bIsTiled then  Tile
        else              Cascade; //To get minimized window inside (panel-changed) window dimensions.
      end;
      //NormalStatus;
    end
    else if MainPanel.Visible then begin
      MainPanel.Visible := False;
    end;
    NormalStatus;
  end;
end;


procedure TFMain.Printcurrentpage1Click(Sender: TObject);
var
  Bitmap: TBitmap;
begin
  if not PrintDialog1.Execute then exit;

  cursor := crHourGlass;

  FMain.Update;

  keybd_event(VK_MENU, 0, 0, 0);
  keybd_event(VK_SNAPSHOT, 0, 0, 0);
  keybd_event(VK_MENU, 0, KEYEVENTF_KEYUP, 0);
  keybd_event(VK_SNAPSHOT, 0, KEYEVENTF_KEYUP, 0);

  //Hack to allow for the keystroke messages to be processed.  If they are not
  //processed before the bitmap is copied from the clipboard, then the correct
  //bitmap will not be on the clipboard for printing.
  Application.ProcessMessages;

  if Clipboard.HasFormat(CF_BITMAP) then 	{ is there a bitmap on the Clipboard? }
  begin
    Bitmap := TBitmap.Create;	{ create bitmap to hold the contents on the Clipboard }
    try
      Bitmap.Assign(Clipboard);	{ get the bitmap off the Clipboard }
      Print(Bitmap);	{ copy the bitmap to the Image }
    finally
      Bitmap.Free;
    end;
  end;
  cursor := crDefault;
end;

procedure TFMain.Print(FormImage: TBitmap);
var
  Info: PBitmapInfo;
  InfoSize: Integer;
  Image: Pointer;
  ImageSize: DWORD;
  Bits: HBITMAP;
  DIBWidth, DIBHeight: Longint;
  PrintWidth, PrintHeight: Longint;
begin
  Printer.BeginDoc;
  try
    Canvas.Lock;
    try
      { Paint bitmap to the printer }
      with Printer, Canvas do
      begin
        Bits := FormImage.Handle;
        GetDIBSizes(Bits, InfoSize, ImageSize);
        Info := AllocMem(InfoSize);
        try
          Image := AllocMem(ImageSize);
          try
            GetDIB(Bits, 0, Info^, Image^);
            with Info^.bmiHeader do
            begin
              DIBWidth := biWidth;
              DIBHeight := biHeight;
            end;
            case PrintScale of
              poProportional:
                begin
                  PrintWidth := MulDiv(DIBWidth, GetDeviceCaps(Handle,
                    LOGPIXELSX), PixelsPerInch);
                  PrintHeight := MulDiv(DIBHeight, GetDeviceCaps(Handle,
                    LOGPIXELSY), PixelsPerInch);
                end;
              poPrintToFit:
                begin
                  PrintWidth := MulDiv(DIBWidth, PageHeight, DIBHeight);
                  if PrintWidth < PageWidth then
                    PrintHeight := PageHeight
                  else
                  begin
                    PrintWidth := PageWidth;
                    PrintHeight := MulDiv(DIBHeight, PageWidth, DIBWidth);
                  end;
                end;
            else
              PrintWidth := DIBWidth;
              PrintHeight := DIBHeight;
            end;
            StretchDIBits(Canvas.Handle, 0, 0, PrintWidth, PrintHeight, 0, 0,
              DIBWidth, DIBHeight, Image, Info^, DIB_RGB_COLORS, SRCCOPY);
          finally
            FreeMem(Image, ImageSize);
          end;
        finally
          FreeMem(Info, InfoSize);
        end;
      end;
    finally
      Canvas.Unlock;
    end;
  finally
    Printer.EndDoc;
  end;
end;

procedure TFMain.DisplayPollingErrorAlarm;
begin
  MessageDlg('Communications with the control appear to be down.  Please close the 5009 PCI program and restart it.', mtError, [mbOK], 0);
end;

procedure TFMain.tPingTimer(Sender: TObject);
var
  bException: boolean;
begin
  bException := FALSE;
  DisablePing;  //to avoid "stacking" these messages.
  if StatusBar1 = nil then   exit;
  if bServerReady then begin
    try
      WaitTillRequestReady;
      bInPingSemaphor := TRUE;
      if WIServlinkControl1.IsCommunicating then begin
        //WaitTillRequestReady;
        if WIServlinkControl1.IsInConfigureMode then begin
          StatusBar1.Panels[ControlStatusPanel].Text := 'Control Status:  Program Mode';
          bInConfigureMode := True;
        end
        else begin
          StatusBar1.Panels[ControlStatusPanel].Text := 'Control Status:  Running';
          bInConfigureMode := False;
        end;
        tLastPing := Time;
      end
      else begin
        StatusBar1.Panels[ControlStatusPanel].Text := 'Control Status:  Not Communicating';
      end
    except
        StatusBar1.Panels[ControlStatusPanel].Text := 'Communications polling error';
        bException := TRUE;
    end;
    bInPingSemaphor := FALSE;
    if bException then begin
      nPollingErrorTime := nPollingErrorTime + tPing.Interval;
      if nPollingErrorTime > 10000 then
        DisplayPollingErrorAlarm;
    end
    else
      nPollingErrorTime := 0;
  end
  else
    StatusBar1.Panels[ControlStatusPanel].Text := 'Control Status:  Not communicating';
  tPing.Interval := DFLT_PING_PERIOD;
  tPing.Enabled := TRUE;  //to avoid "stacking" these messages.
end;


procedure TFMain.ProgramOnLineButtonClick(Sender: TObject);
begin
  ProgramEditClick(Sender);
end;

procedure TFMain.PassCCheck(bReallyPass: boolean);
var
  i : integer;
  CurItem: TWIServlinkItem;
begin
  CurItem := WIServLinkControl1.GetServlinkItemObject(sGAPStartConfig);
  if (CurItem <> nil) then begin
    CurItem.Value := FALSE;
    WIServlinkControl1.ReleaseItemObject(sGAPStartConfig);
  end;
  
  if (bReallyPass) then
    i := MessageDlg('Program Configuration has passed the error check.  Re-Initialize Control?',
                       mtConfirmation,[mbYes, mbCancel], 0)
  else
    i := MessageDlg('Configuration error check has been circumvented.  Re-Initialize Control?',
                       mtConfirmation,[mbYes, mbCancel], 0);
  case i of
    mrYes:
      begin
        DisablePing;
        tMain.Enabled := FALSE;
        fProgramMode.Release;
        fProgramMode := nil;
        WIServlinkControl1.SaveValues;
        StatusBar1.Panels[ControlStatusPanel].Text := RESET_STR;
        ShowStatus('Performing Control Initialization');
        WIServlinkControl1.Reset;
        ChangeProgramMode := CLOSE_MODE;
      end;
    mrCancel:
      begin
        RestartOtherAdvises;
      end;
  end; //case
end;

procedure TFMain.ReportCCheckErrors;
var
  CurItem : TWIServlinkItem;
  i, iLB, iPass, iNumErrors : integer;
  bMore: boolean;
  sItemName, sErrMsg, sAppend : string;
  BranchTo : TControl;
begin

  CurItem := WIServLinkControl1.GetServlinkItemObject(sGAPStartConfig);
  CurItem.Value := FALSE;
  WIServlinkControl1.ReleaseItemObject(sGAPStartConfig);

  if (fErrors = NIL) then
    fErrors := TfErrors.Create(fMain)
  else begin
    fErrors.ListBox1.Clear;
    fErrors.RemoveButton.Enabled := TRUE;
    fErrors.BranchButton.Enabled := TRUE;
  end;

  try
    iNumErrors := 0;
    CurItem := WIServLinkControl1.GetServlinkItemObject(sGAPNumErrors);
    if (CurItem <> nil) then begin
      iNumErrors := CurItem.Value;
      WIServlinkControl1.ReleaseItemObject(sGAPNumErrors);
    end;


    iLB := 0;
    if (iNumErrors>0) then for i := 1 to iNumErrors do begin
      with fErrors.ListBox1.Items do begin
        sItemName := sGAPErrorMsgRoot + IntToStr(i);
        CurItem := WIServLinkControl1.GetServlinkItemObject(sItemName);
        sErrMsg := CurItem.Value;
        WIServlinkControl1.ReleaseItemObject(sItemName);
        sItemName := sGAPErrorNumRoot + IntToStr(i);
        CurItem := WIServLinkControl1.GetServlinkItemObject(sItemName);

        iPass := 1;
        bMore := TRUE;
        while (bMore) do begin
          BranchTo := fProgramMode.GetAssociatedErrorObject(
                                   CurItem.Value, //GAP code used by switch stmt
                                   iPass,         //Which pass this is
                                   bMore,         //Var param:  More passes required?
                                   sAppend );     //String to append to GAP error message?
          if (bMore) then  iPass := iPass+1;
          Add(sErrMsg + sAppend);
          Objects[iLB] := BranchTo;
          iLB := iLB + 1;
          if (iLB > 200) then begin
            MessageDlg('Internal program error:  Too many errors.', mtWarning,[mbOk], 0);
            exit;
          end;
        end; //while bMore
        WIServlinkControl1.ReleaseItemObject(sItemName);
      end; //with ListBox
    end; //for NumErrors

{$IFDEF DebugErrorFunctions}
    for i := 1 to 85 do begin
      with fErrors.ListBox1.Items do begin
        sErrMsg := 'Simulated Error #' + IntToStr(i);
        iPass := 1;
        bMore := TRUE;
        while (bMore) do begin
          BranchTo := fProgramMode.GetAssociatedErrorObject(i, iPass, bMore, sAppend);
          if (bMore) then  iPass := iPass+1;
          Add(sErrMsg + sAppend);
          Objects[iLB] := BranchTo;
          iLB := iLB + 1;
          if (iLB > 200) then begin
            MessageDlg('Internal program error:  Too many errors.', mtWarning,[mbOk], 0);
            exit;
          end;
        end; //while bMore
      end; //with ListBox
    end; //for 1 to 85
{$ENDIF}

    if (iNumErrors > 0) then
      fErrors.Show
    else
      MessageDlg('No errors found!', mtWarning,[mbOK], 0);

  except
    MessageDlg('An error occurred while reporting configuration errors.',
                mtWarning,[mbOK], 0);
  end;

  RestartOtherAdvises;
end;

procedure TFMain.CCheckTimerTimer(Sender: TObject);
var
  CurItem : TWIServlinkItem;
  bCheckDone : boolean;
begin
  bCheckDone := TRUE;
  CCheckTimer.Enabled := FALSE;

  try
    CurItem := WIServLinkControl1.GetServlinkItemObject(sGAPErrorsFound);
    if (CurItem.Value = TRUE) then begin
      WIServlinkControl1.ReleaseItemObject(sGAPErrorsFound);
      ReportCCheckErrors;
    end
    else begin
      WIServlinkControl1.ReleaseItemObject(sGAPErrorsFound);
      CurItem := WIServLinkControl1.GetServlinkItemObject(sGAPNoErrorsFound);
      if (CurItem.Value = TRUE) then begin
        WIServlinkControl1.ReleaseItemObject(sGAPNoErrorsFound);
        if (fErrors <> nil) then begin
          fErrors.Close;
        end;
        PassCCheck(TRUE); //TRUE ==> a legitimate pass
      end
      else begin
        WIServlinkControl1.ReleaseItemObject(sGAPNoErrorsFound);
        CurItem := WIServLinkControl1.GetServlinkItemObject(sGAPStartConfig);
        if (CurItem.Value = TRUE) then
          bCheckDone := FALSE
        else begin
          MessageDlg('Completeness Check has been aborted by control', mtWarning,[mbOK], 0);
        end;
        WIServlinkControl1.ReleaseItemObject(sGAPStartConfig);
      end;
    end;

  except
    MessageDlg('An error occurred during the error check.  Please try again.',
               mtWarning,[mbOK], 0);
    bCheckDone := TRUE;
  end;

  if not bCheckDone then begin
    CCheckTime := CCheckTime + CCheckTimer.Interval;
    if (CCheckTime > 12000) then begin
      MessageDlg('Too much time has elapsed for this completeness check.  You may try again.',
                 mtWarning,[mbOK], 0);
      ReportCCheckErrors;
    end
    else begin
      CCheckTimer.Interval := 1000; //Only wait 1/2 second before re-checking return values
      CCheckTimer.Enabled := TRUE;
    end;
  end;
end;

function TFMain.ExtractName(Pathname: string): string;
var
  rootnm: array[0..50] of char;
  pTemp: pChar;
begin
  StrPCopy(rootnm, PathName);
  pTemp := StrRScan(rootnm, '.');
  if (pTemp <> nil) then
    pTemp^ := #0;
  pTemp := StrRScan(rootnm, '\');
  if (pTemp <> nil) then
    ExtractName := pTemp + 1
  else begin
    pTemp := StrRScan(rootnm, '/');
    if (pTemp <> nil) then
      ExtractName := pTemp + 1
    else
      ExtractName := rootnm;
  end
end;

procedure TFMain.EnableRangeChecking(bEnable: BOOLEAN);
var
  Item1: TWIServlinkItem;
begin
  Item1 := WIServLinkControl1.GetServlinkItemObject(sEnableRGCheck);
  try
    Item1.Value := bEnable;
    if bEnable then begin     //the control won't act until it gets
      sleep(2000);            //TWO enable commands, because it's
      Item1.Value := TRUE;    //potentially going to have an illegal one
    end;                      //that arrived from the mutable item list.
  except
    //do nothing (the try-except is just to attempt to avoid trivial error messages).
  end;
  WIServlinkControl1.ReleaseItemObject(sEnableRGCheck);
end;

function TFMain.ControlInLoadFromFileState: Boolean;
var
  Item1: TWIServlinkItem;
begin
  try
    Item1 := WIServLinkControl1.GetServlinkItemObject(sEnableRGCheck);
    if (Item1.Value = '1') then  ControlInLoadFromFileState := FALSE
    else                         ControlInLoadFromFileState := TRUE;
  except
    ControlInLoadFromFileState := TRUE;
  end;
  WIServlinkControl1.ReleaseItemObject(sEnableRGCheck);
end;

procedure TFMain.Loadfromfile1Click(Sender: TObject);
var
  ConfigIDItem: TWIServlinkItem;
  sConfigID: string;
begin
  WaitTillPingDone;
  if (   (not WIServlinkControl1.IsCommunicating)
      or (not WIServlinkControl1.IsInConfigureMode) ) then begin
    MessageDlg('Control must be in program mode for this command.', mtInformation,[mbOk], 0);
    exit;
  end;
  if (MessageDlg('Loading values from file may take up to 5 minutes during which time the interface will be disabled.  Load anyway?',
                       mtConfirmation,[mbYes, mbCancel], 0) = mrCancel) then
    exit;

  ConfigIDItem := WIServLinkControl1.GetServlinkItemObject('Configuration ID');
  if (ConfigIDItem <> nil) then begin
    sConfigID := ConfigIDItem.Value;
    if (sConfigID <> '') then
      OpenDialog1.Filename := ConfigIDItem.Value + '.' + CFG_FILE_EXT
    else
      OpenDialog1.Filename := DFLT_CFG_FILENM;
  end;
  WIServlinkControl1.ReleaseItemObject('Configuration ID');

  OpenDialog1.DefaultExt := CFG_FILE_EXT;
  OpenDialog1.FilterIndex := CFG_FILE_FILTER;
  OpenDialog1.InitialDir := DFLT_CFG_FILEDIR;
  OpenDialog1.Title := 'Select 5009 configuration file';
  if (OpenDialog1.execute) then begin
    DisablePing;
    Cursor := crHourGlass;
    MainPanel.Enabled := FALSE;
    StatusBar1.Panels[ControlStatusPanel].Text := 'Please Wait...';
    try
      Enabled := FALSE;
      EnableRangeChecking(FALSE);
      WIServlinkConfig1.ConfigureFromFile(OpenDialog1.FileName);

      sConfigID := ExtractName(OpenDialog1.FileName);
      if (sConfigID <> '') then begin
         ConfigIDItem := WIServLinkControl1.GetServlinkItemObject('Configuration ID');
         if (ConfigIDItem <> nil) then begin
           ConfigIDItem.Value := sConfigID; //poke it to control
           WIServlinkControl1.ReleaseItemObject('Configuration ID');
         end;
         Enabled := TRUE;
         MessageDlg(OpenDialog1.Filename + ' file load complete.', mtInformation, [mbOK], 0);
         NormalStatus;
      end;
    except
      StatusBar1.Panels[ControlStatusPanel].Text := 'Error loading multable values';
      MessageDlg('Load from file failed! Verify file compatibility.', mtError, [mbOK], 0);
      Enabled := TRUE;
      NormalStatus;
    end;
    EnableRangeChecking(TRUE);
    tPing.Enabled := TRUE;
  end;
end;

procedure TFMain.Save1Click(Sender: TObject);
var
  ConfigIDItem: TWIServlinkItem;
  sConfigID: string;
begin
  if (MessageDlg('Saving values to file may take up to 5 minutes during which interface will be sluggish and the control should not be re-initialized.  Save anyway?',
                       mtConfirmation,[mbYes, mbCancel], 0) = mrCancel) then
    exit;
  ConfigIDItem := WIServLinkControl1.GetServlinkItemObject('Configuration ID');
  if (ConfigIDItem <> nil) then begin
    sConfigID := ConfigIDItem.Value;
    if (sConfigID <> '') then
      SaveDialog1.Filename := sConfigID + '.' + CFG_FILE_EXT;
  end;
  WIServlinkControl1.ReleaseItemObject('Configuration ID');

  if (SaveDialog1.execute) then begin
    cursor := crHourGlass;
    DisablePing;
    try
      WIServlinkConfig1.SaveToFile(SaveDialog1.FileName);
      sConfigID := ExtractName(SaveDialog1.FileName);
      if (sConfigID <> '') then begin
         ConfigIDItem := WIServLinkControl1.GetServlinkItemObject('Configuration ID');
         if (ConfigIDItem <> nil) then begin
           ConfigIDItem.Value := sConfigID; //poke it to control
           WIServlinkControl1.ReleaseItemObject('Configuration ID');
         end;
         MessageDlg(SaveDialog1.Filename + ' file save complete.', mtInformation, [mbOK], 0);
      end;
    except
      StatusBar1.Panels[ControlStatusPanel].Text := 'Error collecting mutable values';
      MessageDlg('Save to file failed.', mtError, [mbOK], 0);
      StatusBar1.Panels[0].Text := 'Active';
      tPing.Interval := 4000; //(allow user to view message)
    end;
    tPing.Enabled := TRUE;
    cursor := crDefault;
  end;
end;

procedure TFMain.SuspendOtherAdvises;
begin
  fMain.Cursor := crHourGlass;
  if (fProgramMode <> nil) then begin
    fProgramMode.PageControl1.Cursor := crHourGlass;
    fProgramMode.PageControl1.ActivePage.Cursor := crHourGlass;
  end;
  DisablePing;
end;

procedure TFMain.RestartOtherAdvises;
begin
  fMain.Cursor := crDefault;
  if (fProgramMode <> nil) then begin
    fProgramMode.PageControl1.Cursor := crDefault;
    fProgramMode.PageControl1.ActivePage.Cursor := crDefault;
  end;
  tPing.Interval := 500; //Make it run "now"
  tPing.Enabled := bIsOnLine;
end;

function TfMain.UnMaximizeOtherModes(CurForm: TWIForm): boolean;
var
  bReturn: boolean;
begin
  bReturn := FALSE;
  if (fRunMode <> nil) and (CurForm <> TWIForm(fRunMode)) and (fRunMode.WindowState <> wsMinimized) then
  begin
    fRunMode.WindowState := wsNormal;
    bReturn := TRUE;
  end;
  if (fProgramMode <> nil) and (CurForm <> TWIForm(fProgramMode)) and (fProgramMode.WindowState <> wsMinimized) then
  begin
    fProgramMode.WindowState := wsNormal;
    bReturn := TRUE;
  end;
  if (fServiceMode <> nil) and (CurForm <> TWIForm(fServiceMode)) and (fServiceMode.WindowState <> wsMinimized) then
  begin
    fServiceMode.WindowState := wsNormal;
    bReturn := TRUE;
  end;

  UnMaximizeOtherModes := bReturn;
end;

procedure TFMain.RunModeButtonClick(Sender: TObject);
begin
  Run1Click(Sender);
end;

procedure TFMain.FormClose(Sender: TObject; var Action: TCloseAction);
var iResponse: integer;
    bPingWasEnabled : boolean;
begin
  if (bTerminated) then begin
    DisablePing;
    Action := caFree;
    exit;
  end;

  if tPing.Enabled = TRUE then begin
    DisablePing;
    bPingWasEnabled := TRUE;
  end
  else
    bPingWasEnabled := FALSE;
  try
    if (    (fProgramMode <> nil)
        and (ProgramEdit.Checked)
        and (WIServlinkControl1.IsCommunicating) )
    then
      iResponse := MessageDlg('Reset control before exiting program?',mtConfirmation,mbYesNoCancel,0)
    else
      iResponse := mrNo;
  except
    if (MessageDlg('Exit program?',mtConfirmation,[mbYes, mbCancel],0)) = mrYes then
      iResponse := mrNo
    else
      iResponse := mrCancel
  end;

  case iResponse of
    mrYes:
      begin
        tPing.Enabled := bPingWasEnabled;
        Action := caNone;
        if (fProgramMode = nil) then
          ProgramEditClick(Sender);
        fProgramMode.ExitProgramModeButtonClick(Sender);
      end;
    mrCancel:
      begin
        tPing.Enabled := bPingWasEnabled;
        Action := caNone; //don't do anything
      end;
    mrNo:
      begin
        DisablePing;
        Action := caFree;
      end;
  end; //case
end;

procedure TFMain.Program1Click(Sender: TObject);
var
  CurItem: TWIServlinkItem;
begin
  if fRunMode <> nil then begin
    ProgramEdit.Enabled := FALSE;
    exit;
  end;
  if not bIsOnLine then begin
    ProgramEdit.Enabled := TRUE;
    exit;
  end;
  if bInConfMode then begin
    ProgramEdit.Enabled := TRUE;
    exit;
  end;

  try
    CurItem := WIServlinkControl1.GetServlinkItemObject(sGAPConfEnabled);

    if (CurItem.Value <> '1') then  ProgramEdit.Enabled := FALSE
    else                            ProgramEdit.Enabled := TRUE;
  except
    ProgramEdit.Enabled := TRUE;
  end;
  WIServlinkControl1.ReleaseItemObject(sGAPConfEnabled);

end;

/////////////////////////////////////////////////////////////

procedure TFMain.UpdateChildrensMonStatus( Parent: TWinControl;
                                           bMonitorMode: Boolean );
var
  i: integer;
  Obj: TComponent;
begin

  for i := 0 to (Parent.ControlCount-1) do
  begin
    Obj := Parent.Controls[i];
    if ((not bMonitorMode) and ((Obj.Tag and IP_LOCK_CM) = IP_LOCK_CM)) then begin
      ;//do nothing
    end
    else if (Obj is TWinControl) then begin
      if Obj is TW5009SpinEdit then
        TW5009SpinEdit(Obj).IsMonitorOnly := bMonitorMode
      else if Obj is TW5009SpinTune then
        TW5009SpinTune(Obj).IsMonitorOnly := bMonitorMode
      else if Obj is TWIEnumComboBox then
        TWIEnumComboBox(Obj).IsMonitorOnly := bMonitorMode
      else if Obj is TWIStringEdit then
        TWIStringEdit(Obj).IsMonitorOnly := bMonitorMode
      else if Obj is TWIDAOneShotButton then
        TWIDAOneShotButton(Obj).IsMonitorOnly := bMonitorMode
      else if Obj is TWIDAMomentaryButton then
        TWIDAMomentaryButton(Obj).IsMonitorOnly := bMonitorMode
      else if Obj is TWIOneShotButton then
        TWIOneShotButton(Obj).IsMonitorOnly := bMonitorMode
      else if Obj is TWIMomentaryButton then
        TWIMomentaryButton(Obj).IsMonitorOnly := bMonitorMode
      else if Obj is TWIToggleButton then
        TWIToggleButton(Obj).IsMonitorOnly := bMonitorMode
      else if Obj is TWICheckBox then
        TWICheckBox(Obj).IsMonitorOnly := bMonitorMode
       else if (TWinControl(Obj).ControlCount > 0) then
        UpdateChildrensMonStatus(TWinControl(Obj), bMonitorMode);
    end;
  end;
end;


end.

